//Wheel Objects
var lfw : WheelCollider;
var rfw : WheelCollider;
var lrw : WheelCollider;
var rrw : WheelCollider;
var lfwM : Transform;
var rfwM : Transform;
var lrwM : Transform;
var rrwM : Transform;

private var lfwRot=0;
private var rfwRot=0;
private var lrwRot=0;
private var rrwRot=0;

//Vehicle Specifications
var steerMax=10; //maximum wheel steer for front wheels
var steerRate=10; //rate the wheel turns
var engineMax=15; //maxium power (motor torque) of wheels
var engineAcc=15; //acceleration
private var engineCur=0.0;
var brakeMax=50; //maximum brake torque
var is4WD=true;  //True if vehicle is 4 Wheel Drive, False if FWD
var isRWD=true;  //True if vehicle is RWD, otherwise FWD (4WD overrides this)

function Start() {
	
	rfw.radius=lfw.radius;
	lrw.radius=lfw.radius;
	rrw.radius=lfw.radius;
	rfw.suspensionDistance=lfw.suspensionDistance;
	lrw.suspensionDistance=lfw.suspensionDistance;
	rrw.suspensionDistance=lfw.suspensionDistance;
	rfw.suspensionSpring=lfw.suspensionSpring;
	lrw.suspensionSpring=lfw.suspensionSpring;
	rrw.suspensionSpring=lfw.suspensionSpring;
	rfw.mass=lfw.mass;
	lrw.mass=lfw.mass;
	rrw.mass=lfw.mass;
	rfw.forwardFriction=lfw.forwardFriction;
	lrw.forwardFriction=lfw.forwardFriction;
	rrw.forwardFriction=lfw.forwardFriction;
	rfw.sidewaysFriction=lfw.sidewaysFriction;
	lrw.sidewaysFriction=lfw.sidewaysFriction;
	rrw.sidewaysFriction=lfw.sidewaysFriction;
	transform.GetComponentInChildren(Rigidbody).centerOfMass=Vector3(0,-.9,0); //TODO - Make this a variable
}

function Update(){
	lfwRot=Mathf.Repeat(lfwRot + Time.deltaTime * lfw.rpm * 360.0 / 60.0, 360.0);
	lfwM.localRotation=Quaternion.Euler(lfwRot, lfw.steerAngle, 0.0 );
	rfwRot=Mathf.Repeat(rfwRot + Time.deltaTime * rfw.rpm * 360.0 / 60.0, 360.0);
	rfwM.localRotation=Quaternion.Euler(rfwRot, rfw.steerAngle, 0.0 );
	lrwRot=Mathf.Repeat(lrwRot + Time.deltaTime * lrw.rpm * 360.0 / 60.0, 360.0);
	lrwM.localRotation=Quaternion.Euler(lrwRot, lrw.steerAngle, 0.0 );
	rrwRot=Mathf.Repeat(rrwRot + Time.deltaTime * rrw.rpm * 360.0 / 60.0, 360.0);
	rrwM.localRotation=Quaternion.Euler(rrwRot, rrw.steerAngle, 0.0 );
}

function Steer(dir:float){
	if (dir!=0){
		lfw.steerAngle+=dir*steerRate*Time.fixedDeltaTime;
	}
	if (lfw.steerAngle>steerMax){lfw.steerAngle=steerMax;}
	if (lfw.steerAngle<-steerMax){lfw.steerAngle=-steerMax;}
	rfw.steerAngle=lfw.steerAngle;
}

function Accelerate(spd:float){
	if (float!=0){
		engineCur+=spd*engineAcc*Time.fixedDeltaTime;
	}
	if (engineCur>engineMax){engineCur=engineMax;}
	if (engineCur<-engineMax){engineCur=-engineMax;}
	if (is4WD){
		lfw.motorTorque=engineCur;
		rfw.motorTorque=engineCur;
		lrw.motorTorque=engineCur;
		rrw.motorTorque=engineCur;
	}
	else if (isRWD){
		lrw.motorTorque=engineCur;
		rrw.motorTorque=engineCur;
	}
	else{
		lfw.motorTorque=engineCur;
		rfw.motorTorque=engineCur;	
	}
}

function Brake(spd:float){
	if (spd>0){
		lfw.brakeTorque=brakeMax*spd;
		rfw.brakeTorque=brakeMax*spd;
		rrw.brakeTorque=brakeMax*spd;
		lrw.brakeTorque=brakeMax*spd;
	}
	else{
		lfw.brakeTorque=0;
		rfw.brakeTorque=0;
		rrw.brakeTorque=0;
		lrw.brakeTorque=0;
	}
}